/**
 * jquery.customIndicator.js
 * 
 * @version 1.0
 * @author youngjun cho
 * @description indicator
 * @date 2014.10.08
 * 
 */

"use strict";

(function ($) {
    
    $.customIndicator = {
        defaults : {
            /**
             * fixFormTable ɼ
             */
            indicator : true  // true : indicator  , false : indicator ̻ 
            , debug : false    // true : console.log  debug ޼ , false : debug ޼  .
            , indicatorObj : "#custom_indicator"    // indicator's DOM.
            , indicatorBackgroundColor : "#FFFFFF"  // indicator  : transparent, #000000, #FFFFFF, ...
            , indicatorBackgroundZIndex : 1000  // indicator  z-index
            , indicatorBackgroundOpacity : 0.1  // indicator  opacity : 1.0, 0.5
            , indicatorWidth : "230px"          // indicator  width
            , indicatorHeight : "32px"          // indicator  height
            , indicatorTop : "50%"              // indicator  top
            , indicatorLeft : "50%"             // indicator  left
            , indicatorMargin : "-16px 0 0 -115px"  // indicator  margin
            , indicatorPadding : "10px 0 10px 0"    // indicator  padding
            , indicatorZindex : 1001                // indicator  z-index
            , indicatorImageUrl : "/test/ajax-loader1.gif"  // indicator  ̹
            , indicatorColor : "#000000"  // indicator   transparent, #000000, #FFFFFF, ...
            , indicatorOpacity : 0.5        // indicator  opacity
            , indicatorFontColor : "#FFFFFF"    // indicator  Ʈ
            , indicatorFontWeight : "bold"      // indicator  ƮŸ
            , indicatorFontFamily : "dotum"     // indicator  Ʈ
            , indicatorFontSize : "13px"        // indicator  Ʈũ
            , indicatorText : "óԴϴ..."       // indicator  ؽƮ
        },
        checkIndicator : function(target) {
            /**
             * indicator element  ϴ üũ.
             */
            var isExistIndicator = false;
            try {
                if($.customIndicator.defaults.indicator === true) {
                    isExistIndicator = $("#custom_indicator", target).length > 0 ? true : false; 
                }
            } catch(e) {
                $.customIndicator._log("checkIndicator", "Exception : " + e);
            }
            return isExistIndicator;
        },
        show : function(target) {
            /**
             * indicator element  body  ߰ϰ, show.
             */
            try {
                if($.customIndicator.defaults.indicator === true) {
                    if ($.customIndicator.checkIndicator(target) === false) {
                        var ajaxIndicatorHtml = "";
                        
                        // start : indicator ̾  ü
                        ajaxIndicatorHtml = ajaxIndicatorHtml + "<div id='"+$.customIndicator.defaults.indicatorObj.replace("#","")+"' style='display: none; position: absolute; z-index: "+$.customIndicator.defaults.indicatorBackgroundZIndex+"; top: 0; left: 0; width: 100%; height: 100%; '>";
                        
                        // start :  
                        ajaxIndicatorHtml = ajaxIndicatorHtml + "   <div style='position: absolute; z-index: "+$.customIndicator.defaults.indicatorBackgroundZIndex+"; top: 0; left: 0; width: 100%; height: 100%; background-color: "+$.customIndicator.defaults.indicatorBackgroundColor+"; opacity: "+$.customIndicator.defaults.indicatorBackgroundOpacity+"; filter:Alpha(opacity="+($.customIndicator.defaults.indicatorBackgroundOpacity * 100)+");'>";
                        ajaxIndicatorHtml = ajaxIndicatorHtml + "   </div>";    // end :  
                        
                        // start :  
                        ajaxIndicatorHtml = ajaxIndicatorHtml + "   <div style='position: absolute; display: inline-block; width: "+$.customIndicator.defaults.indicatorWidth+"; height: "+$.customIndicator.defaults.indicatorHeight+"; top: "+$.customIndicator.defaults.indicatorTop+"; left: "+$.customIndicator.defaults.indicatorLeft+"; margin: "+$.customIndicator.defaults.indicatorMargin+"; padding: "+$.customIndicator.defaults.indicatorPadding+"; text-align: center; z-index: "+$.customIndicator.defaults.indicatorZindex+"; background-color: "+$.customIndicator.defaults.indicatorColor+"; opacity: "+$.customIndicator.defaults.indicatorOpacity+"; filter:Alpha(opacity="+($.customIndicator.defaults.indicatorOpacity * 100)+"); color: "+$.customIndicator.defaults.indicatorFontColor+"; font-weight: "+$.customIndicator.defaults.indicatorFontWeight+"; font-family: "+$.customIndicator.defaults.indicatorFontFamily+"; font-size: "+$.customIndicator.defaults.indicatorFontSize+";'>";
                        ajaxIndicatorHtml = ajaxIndicatorHtml + "       <img src='"+$.customIndicator.defaults.indicatorImageUrl+"'>&nbsp;"+$.customIndicator.defaults.indicatorText+"";
                        ajaxIndicatorHtml = ajaxIndicatorHtml + "   </div>";    // end :  
                        
                        ajaxIndicatorHtml = ajaxIndicatorHtml + "</div>";   // end : indicator ̾  ü
                        
                        //$("body", target).append(ajaxIndicatorHtml);
                        target.$("body").append(ajaxIndicatorHtml);
                        target.$($.customIndicator.defaults.indicatorObj).show();
                    } else {
                        target.$($.customIndicator.defaults.indicatorObj).show();
                    }
                }
            } catch(e) {
                $.customIndicator._log("showIndicator", "Exception : " + e);
            }
        },
        hide : function(target) {
            /**
             * indicator element  hide.
             */
            try {
                //target.$($.fixFormTable.defaults.indicatorObj).hide();
                target.$($.customIndicator.defaults.indicatorObj).fadeOut();
            } catch(e) {
                $.customIndicator._log("hideIndicator", "Exception : " + e);
            }
        },
        _log : function(_position, _msg) {
            /**
             * console.log  Լ.
             */
            try {
                if ($.customIndicator.defaults.debug === true) {
                    var logMsg = "====> [:: jquery.customIndicator.js ::] " + _position + ", " + _msg;
                    
                    if (typeof console == "object") {
                        console.log(logMsg);    
                    } else {
                        alert(logMsg);  // console.log   ʴ  (IE8 )
                    }
                }
            } catch(e) {}
        }
    };
    
})(jQuery);
